import _extends from "@babel/runtime/helpers/esm/extends";
import * as React from 'react';
import { Alert } from 'rsuite-notification';
import Icon from '../Icon';
import { STATUS_ICON_NAMES } from '../constants';
import { getClassNamePrefix } from '../utils/prefix';
var defaultOptions = {
  classPrefix: getClassNamePrefix() + "notification"
};
Alert.config(defaultOptions);

function appendIcon(type, content) {
  return React.createElement("div", null, React.createElement(Icon, {
    icon: STATUS_ICON_NAMES[type]
  }), content);
}

function proxy(type) {
  return function (content, duration, onClose) {
    Alert[type](appendIcon(type, content), duration, onClose);
  };
}

export default {
  info: proxy('info'),
  success: proxy('success'),
  warning: proxy('warning'),
  error: proxy('error'),
  config: function config(options) {
    Alert.config(_extends({}, defaultOptions, {}, options));
  }
};